package com.jojubanking.boot.module.system.service.building;

import java.util.*;
import javax.validation.*;
import com.jojubanking.boot.module.system.controller.admin.building.vo.*;
import com.jojubanking.boot.module.system.controller.admin.dept.vo.dept.DeptListReqVO;
import com.jojubanking.boot.module.system.dal.dataobject.building.BuildingDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;
import com.jojubanking.boot.module.system.dal.dataobject.dept.DeptDO;

/**
 * 楼层导视 Service 接口
 *
 * @author admin
 */
public interface BuildingService {

    /**
     * 创建楼层导视
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createBuilding(@Valid BuildingCreateReqVO createReqVO);

    /**
     * 更新楼层导视
     *
     * @param updateReqVO 更新信息
     */
    void updateBuilding(@Valid BuildingUpdateReqVO updateReqVO);

    /**
     * 删除楼层导视
     *
     * @param id 编号
     */
    void deleteBuilding(Long id);

    /**
     * 获得楼层导视
     *
     * @param id 编号
     * @return 楼层导视
     */
    BuildingDO getBuilding(Long id);

    /**
     * 获得楼层导视列表
     *
     * @param ids 编号
     * @return 楼层导视列表
     */
    List<BuildingDO> getBuildingList(Collection<Long> ids);

    /**
     * 筛选楼层导视列表
     *
     * @param reqVO 筛选条件请求 VO
     * @return 部门列表
     */
    List<BuildingDO> getSimpleBuildings(BuildingListReqVO reqVO);

    List<BuildingDO> getBuildingsByParentIdFromCache(Long parentId, boolean recursive);

    /**
     * 获得楼层导视分页
     *
     * @param pageReqVO 分页查询
     * @return 楼层导视分页
     */
    PageResult<BuildingDO> getBuildingPage(BuildingPageReqVO pageReqVO);

    /**
     * 获得楼层导视列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 楼层导视列表
     */
    List<BuildingDO> getBuildingList(BuildingExportReqVO exportReqVO);

}
